# -*- coding: utf-8 -*- #
# Copyright 2025 Google LLC. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
"""Common utilities and shared helpers for Model armor commands."""
from googlecloudsdk.calliope import exceptions


def ValidateEnum(enum_value, enum_class, arg, message=''):
  """Validates the argument with allowed enum values."""
  try:
    enum_class(enum_value.upper().replace('-', '_'))
    return True
  except TypeError:
    raise exceptions.InvalidArgumentException(arg, message)
